#ifndef _ADATA_AVR2UTIL_FIRMWARE_H
#define _ADATA_AVR2UTIL_FIRMWARE_H

#include "connection.h"

extern int
avr2utilWriteApplicationFlash(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  uint32_t address,
  const uint8_t* pBuffer,
  uint32_t length);

extern int
avr2utilReadApplicationFlash(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  uint32_t address,
  uint8_t* pBuffer,
  uint32_t length);

extern int
avr2utilVerifyApplicationFlash(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  uint32_t address,
  const uint8_t* pBuffer,
  uint32_t length);

extern int
avr2utilUpdateOrVerifyFirmwareCommand(
  DeviceHandle* pDevice,
  bool_t bVerbose,
  bool_t bVerifyOnly,
  const TCHAR* pFilename);

extern int
avr2utilUpdateOrVerifyBoardConfigCommand(
  DeviceHandle* pDevice,
  bool_t bVerbose,
  bool_t bVerifyOnly,
  const TCHAR* pFilename);

extern int
avr2utilUpdateOrVerifyVpdCommand(
  DeviceHandle* pDevice,
  bool_t bVerbose,
  bool_t bVerifyOnly,
  const TCHAR* pFilename);

extern int
avr2utilSaveFirmwareCommand(
  DeviceHandle* pDevice,
  bool_t bVerbose,
  const TCHAR* pFilename);

extern int
avr2utilSaveBoardConfigCommand(
  DeviceHandle* pDevice,
  bool_t bVerbose,
  const TCHAR* pFilename);

extern int
avr2utilSaveVpdCommand(
  DeviceHandle* pDevice,
  bool_t bVerbose,
  const TCHAR* pFilename);

#endif
