#ifndef _ADATA_AVR2UTIL_I2C_H
#define _ADATA_AVR2UTIL_I2C_H

#include "connection.h"

extern int
avr2utilI2cReadToFileCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int bus,
  unsigned int dev,
  unsigned int address,
  unsigned int length,
  const TCHAR* pFilename);

extern int
avr2utilI2cVerifyWithFileCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int bus,
  unsigned int dev,
  unsigned int address,
  const TCHAR* pFilename);

extern int
avr2utilI2cWriteFromFileCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int bus,
  unsigned int dev,
  unsigned int address,
  const TCHAR* pFilename);

extern int
avr2utilI2cReadCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int bus,
  unsigned int dev,
  unsigned int address,
  unsigned int length);

extern int
avr2utilI2cWriteCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int bus,
  unsigned int dev,
  unsigned int address,
  unsigned int length,
  const uint8_t* pBytes);

extern int
avr2utilI2cWriteReadCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int bus,
  unsigned int dev,
  unsigned int writeCount,
  unsigned int readCount,
  const uint8_t* pBytes);

#endif
