#ifndef _ADATA_AVR2UTIL_MISC_H
#define _ADATA_AVR2UTIL_MISC_H

#include "connection.h"

/* This function sends an invalid command to the microcontroller, which should always result in a time out.
** This can be used as a simple test of the timeout mechanism or for testing cancellation in the driver. */
extern int
avr2utilTestTimeoutCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose);

/* This function sends an an arbitary command to the microcontroller. It is intended for firmware
** testing by Alpha Data. */
extern int
avr2utilRawCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int readCount,
  unsigned int writeCount,
  const uint8_t* pWriteBytes);

#endif