#if defined(_WIN32)

/* Windows */
# include <windows.h>
# include <tchar.h>

#else

/* Linux or VxWorks */
# define _T(x) x

#endif

#include "model_info.h"

const TCHAR*
avr2utilGetModelName(
  uint32_t drawingNumber)
{
  const TCHAR* pModelName = _T("UNRECOGNIZED");
  
  switch (drawingNumber) {
  case DRAWING_NUM_ADMXRCKU1:
    pModelName = _T("ADM-XRC-KU1");
    break;

  case DRAWING_NUM_ADMPCIE8V3:
    pModelName = _T("ADM-PCIE-8V3");
    break;

  case DRAWING_NUM_ADMPCIE8K5:
    pModelName = _T("ADM-PCIE-8K5");
    break;

  case DRAWING_NUM_ADMPCIEUCC:
    pModelName = _T("ADM-PCIE-UCC");
    break;

  case DRAWING_NUM_ADMPCIE9V3:
    pModelName = _T("ADM-PCIE-9V3");
    break;

  case DRAWING_NUM_ADMPCIE9V5:
    pModelName = _T("ADM-PCIE-9V5");
    break;

  case DRAWING_NUM_ADMPCIE8K5_FH:
    pModelName = _T("ADM-PCIE-8K5-FH");
    break;

  case DRAWING_NUM_ADMPCIE9V3G:
    pModelName = _T("ADM-PCIE-9V3G");
    break;

  case DRAWING_NUM_ADMPCIE9H7:
    pModelName = _T("ADM-PCIE-9H7");
    break;

  case DRAWING_NUM_ADMSDEVBASE:
    pModelName = _T("ADM-SDEV-BASE");
    break;

  case DRAWING_NUM_ADMPCIE9H3:
    pModelName = _T("ADM-PCIE-9H3");
    break;

  case DRAWING_NUM_ADMVPX39Z2:
    pModelName = _T("ADM-VPX3-9Z2");
    break;

  case DRAWING_NUM_ADMXRC9R1:
    pModelName = _T("ADM-XRC-9R1");
    break;

  case DRAWING_NUM_ADMVPX39V2:
    pModelName = _T("ADM-VPX3-9V2");
    break;

  case DRAWING_NUM_ADMPCIE9V6:
    pModelName = _T("ADM-PCIE-9V6");
    break;

  case DRAWING_NUM_ADMPCIE9V7:
    pModelName = _T("ADM-PCIE-9V7");
    break;

  case DRAWING_NUM_ADMPA100:
    pModelName = _T("ADM-PA100");
    break;
  
  case DRAWING_NUM_ADMPA101:
    pModelName = _T("ADM-PA101");
    break;
  
  case DRAWING_NUM_ADCXMCSTANDALONE:
    pModelName = _T("ADC-XMC-STANDALONE");
    break;

  case DRAWING_NUM_ADMXRC9Z1:
    pModelName = _T("ADM-XRC-9Z1");
    break;

  case DRAWING_NUM_ADMXRCKU1AT8:
    pModelName = _T("ADM-XRC-KU1A-T8");
    break;

  case DRAWING_NUM_ADMPCIETRC01:
    pModelName = _T("ADM-PCIE-TRC01");
    break;

  case DRAWING_NUM_ADMPCIE9V8:
    pModelName = _T("ADM-PCIE-9V8");
    break;

  case DRAWING_NUM_ADMAD01474:
    pModelName = _T("ADM-AD01474");
    break;
  }
  
  return pModelName;
}
