#ifndef _ADATA_SPI_FLASH_H
#define _ADATA_SPI_FLASH_H

#include <sdk_common.h>

#include "connection.h"
#include "intel_hex.h"

extern int
avr2utilSpiRawCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int chipIndex,
  unsigned int readCount,
  unsigned int writeCount,
  const uint8_t* pWriteBytes);

extern int
avr2utilSpiInfoCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int chipIndex);

extern int
avr2utilSpiCheckBlankCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int chipIndex,
  unsigned int address,
  unsigned int count);

extern int
avr2utilSpiEraseCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int chipIndex,
  unsigned int address,
  unsigned int count);

extern int
avr2utilSpiProgramIntelHexCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int chipIndex,
  const TCHAR* pFilename,
  int32_t translation);

extern int
avr2utilSpiVerifyIntelHexCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int chipIndex,
  const TCHAR* pFilename,
  int32_t translation);

extern int
avr2utilSpiSaveIntelHexCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  unsigned int chipIndex,
  const TCHAR* pFilename,
  unsigned int address,
  unsigned int count);

#endif