#ifndef _ADATA_AVR2UTIL_VPD_H
#define _ADATA_AVR2UTIL_VPD_H

#include "connection.h"

#define VPD_BASE_ADDR    (0x1FF00U) /* Address in Application Flash where VPD lives */
#define VPD_LENGTH_LIMIT (128U)     /* Maximum possible size of VPD block */

#define GET_VPD_VAL8(addr)  ((uint8_t)(cpu_to_le8(((uint8_t)(addr)[0]) << 0)))
#define GET_VPD_VAL16(addr) ((uint16_t)(cpu_to_le16((((uint16_t)(addr)[0]) << 0) + (((uint16_t)(addr)[1]) << 8))))
#define GET_VPD_VAL32(addr) ((uint32_t)(cpu_to_le32((((uint32_t)(addr)[0]) << 0) + (((uint32_t)(addr)[1]) << 8) + (((uint32_t)(addr)[2]) << 16) + (((uint32_t)(addr)[3]) << 24))))

extern void
avr2utilGetBoardRevision(
  const uint8_t *pVpd,
  uint32_t nDrawingNumber,
  uint8_t* pnBoardRevMajor, 
  uint8_t* pnBoardRevMinor);

extern int
avr2utilRequestVpd(
  const DeviceHandle* pDevice,
  bool_t bVerbose,
  uint8_t* pVpdData); /* Must be at least 256 bytes in size */

extern int
avr2utilDisplayVpdCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose);

extern int
avr2utilDisplayVpdRawCommand(
  const DeviceHandle* pDevice,
  bool_t bVerbose);

#endif